--[[----------------------------------------------------------------------------

WFPerformanceReportTestUtils.lua

--------------------------------------------------------------------------------

ADOBE CONFIDENTIAL
------------------
Copyright 2015 Adobe Systems Incorporated
All Rights Reserved.

NOTICE: All information contained herein is, and remain the property of
Adobe Systems Incorporated and its suppliers, if any. The intellectual and
technical concepts contained herein are proprietary to Adobe Systems
Incorporated and its suppliers and may be covered by U.S. and Foreign
Patents, patents in process, and are protected by trade secret or copyright
law.  Dissemination of this information or reproduction of this material is
strictly forbidden unless prior written permission is obtained from
Adobe Systems Incorporated.

----------------------------------------------------------------------------]]--

	-- RxLua
local Rx = require 'Rx'
local Observable = Rx.Observable

	-- WF.core.rxlua
local WFRxScheduler = require "WFRxScheduler"


--============================================================================--

-- @mark WFPerformanceReportTestUtils namespace

local WFPerformanceReportTestUtils = {}

--------------------------------------------------------------------------------

 function WFPerformanceReportTestUtils.sendsOnNextAndCompleted( maybeNEvents )

	local nEvents = maybeNEvents or math.random( 1, 5 )

	return Observable.timer( 0, 1, WFRxScheduler.sharedScheduler() )
		:take( nEvents ), nEvents

end

--------------------------------------------------------------------------------

 function WFPerformanceReportTestUtils.sendsOnNextAndError( maybeNEvents )

	local nEvents = maybeNEvents or math.random( 1, 5 )

	return Observable.timer( 0, 1, WFRxScheduler.sharedScheduler() )
		:take( nEvents )
		:concat( Observable.throw( "ExpectedError" ) ), nEvents

end

--------------------------------------------------------------------------------

return WFPerformanceReportTestUtils
